"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TextProvider = void 0;
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var react_1 = require("@emotion/react");
var useTheme_1 = __importDefault(require("../useTheme"));
var lodash_1 = require("lodash");
var react_2 = require("react");
var useSs_1 = __importDefault(require("../useSs"));
var core_1 = require("@capsizecss/core");
var isInlineContext_1 = __importDefault(require("./isInlineContext"));
var useStyleCss_1 = __importDefault(require("./useStyleCss"));
var ssProps = ["bg", "radius"];
var IsInlineProvider = isInlineContext_1.default.Provider;
var propsToOmit = __spreadArray(__spreadArray([], ssProps, true), [
    "color",
    "weight",
    "bold",
    "underline",
    "font",
    "size",
    "align",
    "as",
], false);
var textContext = (0, react_2.createContext)({});
var Provider = textContext.Provider;
var TextProvider = function (_a) {
    var children = _a.children, props = __rest(_a, ["children"]);
    return ((0, jsx_runtime_1.jsx)(Provider, __assign({ value: props }, { children: children })));
};
exports.TextProvider = TextProvider;
exports.default = (function (props) {
    var _a, _b, _c;
    var _d = (0, useTheme_1.default)(), fontSize = _d.fontSize, defaultFont = _d.defaultFont, fonts = _d.fonts;
    var ss = (0, useSs_1.default)((0, lodash_1.pick)(props, ssProps));
    var contextProps = (0, react_2.useContext)(textContext);
    props = __assign(__assign({}, contextProps), props);
    var headingLevel = props.headingLevel;
    var font = fonts[(_a = props.font) !== null && _a !== void 0 ? _a : defaultFont];
    var size = (_b = props.size) !== null && _b !== void 0 ? _b : "md";
    var styleCss = (0, useStyleCss_1.default)(props);
    if (!props.children)
        return null;
    return ((0, jsx_runtime_1.jsx)(IsInlineProvider, __assign({ value: true }, { children: (0, react_1.jsx)((_c = props.as) !== null && _c !== void 0 ? _c : (headingLevel ? "h".concat(headingLevel) : "p"), __assign(__assign({}, (0, lodash_1.omit)(props, propsToOmit)), { css: (0, react_1.css)(ss, styleCss, __assign({ fontFamily: font.name, textAlign: props.align }, (0, core_1.createStyleObject)({
                capHeight: fontSize(size).raw,
                lineGap: fontSize(size).raw,
                fontMetrics: font.metrics,
            }))) })) })));
});
