import { round, isNull } from "lodash";
// {s, space, c, color}
// p="sm" p={space('sm').raw + 2}
export var createSize = function (pixels) { return ({
    raw: isNull(pixels) ? null : Math.max(1, round(pixels)),
    get s() {
        return this.toString();
    },
    toString: function toString() {
        if (typeof this.raw === "number")
            return "".concat(this.raw, "px");
        else
            return undefined;
    },
    css: function () {
        return this.toString();
    },
}); };
export var linearSize = function (base, coeff) { return function (s) {
    return createSize(s === null ? null : s * coeff + base);
}; };
export var goldenRatioSize = function (s) {
    return createSize(s === null ? null : round(Math.pow(1.618, s) * 16, 3));
};
